+++
title = "ftest.toml"
insert_anchor_links = "right"
weight = 5
+++

## `fest.toml` or Job Manifest

Job manifest is defined in `ftest.toml` file in the specimen's
subdirectory.

## ftest.toml contents:

It can contain information on:

### 1. Initialization code

The code that needs to be run to prepare the test environment. ftest
runs Docker containers to initialize test environments.

#### Example

[forgejo-init-script](https://git.batsense.net/ForgeFlux/forgejo-init-script) performs the following operations in a sequence:

1. Install Forgejo (the binary starts with a web installer that accepts
   configuration parameters for database, mailer, etc.)
2. Create accounts
3. Create repositories
4. Create issues
5. Create access tokens

NOTE: Some of these operations are irrelevant, as I (@realaravinth) had nicked them from
another project of mine and was too lazy to modify ;)

### 2. Test Suite

A test suite is a collection of tests. For instance, ActivityPub is a
test suite that could include tests for the WebFinger protocol and the
Nodeinfo protocol.

### 3. Tests

A test is a docker container that tests the
[specimen](@/ftest/terminology.md#specimen) for a specific protocol or
feature.

#### Example

[Nodeinfo test](https://git.batsense.net/nodeinfo-test) is the simplest
test available within ftest at the moment. It tests the specimen's
Nodeinfo implementation against the [Nodeinfo specification](https://nodeinfo.diaspora.software/protocol.html).

Please see [here](/ftest/tests.md) for developing new tests.
